#include "common.h"
#include <assert.h>

char msg[120] = "AAAAAAAAAAAAAAAAAAAA0000000000AAAAAAAAAA000000000000000000001111111111qqqqqqqqqqqqqqqqqqqq11111111111111111111111111111";
char msg2[200] = "000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000";

int main(int argc, char **argv)
{
	int fd;
	int res = 0;
	struct bpf_test test;
	if (bpf_test_load("bpf_complex.o", &test) != 0)
		return -1;

	if ((fd = open("tst", O_RDWR | O_CREAT, 0644)) < 0) {
		fprintf(stderr, "Unable to open\n");
		res = -1;
		goto cleanup;
	}

	size_t bytes_written;
	size_t bytes_after_compression;

	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);
	assert(bytes_written == 0);
	assert(bytes_after_compression == 0);

	do_write(fd, msg, strlen(msg), 0);
	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);
	assert(bytes_written == strlen(msg));
	assert(bytes_after_compression == 79);

	do_write(fd, msg, strlen(msg), strlen(msg));
	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);
	assert(bytes_written == 2 * strlen(msg));
	assert(bytes_after_compression == 79 * 2);

	do_write(fd, msg2, strlen(msg2), strlen(msg) * 2);
	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);
	assert(bytes_written == 2 * strlen(msg) + strlen(msg2));
	assert(bytes_after_compression == 223);
	close(fd);

cleanup:
	bpf_test_cleanup(&test);
	return res;
}
