#include "common.h"
#include <assert.h>
char msg[] = "xyzzy xyzzy xyzzy\n";
int main(int argc, char **argv)
{
	int fd;
	int res = 0;
	struct bpf_test test;
	if (bpf_test_load("bpf_reset.o", &test) != 0)
		return -1;

	if ((fd = open("tst", O_RDWR | O_CREAT, 0644)) < 0) {
		fprintf(stderr, "Unable to open\n");
		res = -1;
		goto cleanup;
	}

	size_t bytes_written;
	size_t bytes_after_compression;
	
	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);
	assert(bytes_written == 0);
	assert(bytes_after_compression == 0);
	
	do_write(fd, msg, strlen(msg), 0);
	char buf[20];
	do_read(fd, buf, strlen(msg), 0);
	
	int len = strlen(buf);
	assert(len == 18);
	assert(strcmp(buf, msg) == 0);
	
	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);	
	assert(bytes_written == strlen(msg));
	assert(bytes_after_compression == 2);

	syscall(464, fd);
	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);
	assert(bytes_written == 0);
	assert(bytes_after_compression == 0);
	
	close(fd);


cleanup:
    bpf_test_cleanup(&test);
	return res;
}
