#!/bin/bash

cd $(dirname $0)
#make

COUNTER_ALL=0
COUNTER_SUCCESS=0

run() {
	tst_exec=$1
	arg=$2
	ok=1
	((COUNTER_ALL+=1))
	echo === Test $tst_exec ===
	rm -f tst
	if ! ./$tst_exec $arg ; then
		echo "Exec failed"
		ok=0
	fi

	[ "$ok" == "1" ] && ((COUNTER_SUCCESS+=1)) && echo OK
}

do_check_perm() {
	((COUNTER_ALL+=1))
	echo "==== CHECK PERM $COUNTER"
	./check_perm /tmp/test && ((COUNTER_SUCCESS+=1)) && echo OK
}

echo "*** GENERAL TESTS ***"
run simple
run reset
run complex
run vector

echo "*** FAILURE TESTS (will produce some error messages) ***"
run fail_ctx
run fail_ctx 2

echo "*** PERMISSION TESTS ***"

rm -f /tmp/test
touch /tmp/test
chown 0:0 /tmp/test
chmod 660 /tmp/test

do_check_perm "Same owner, 0660 mode"

chown 1000:0 /tmp/test
do_check_perm "Other user"

chown 0:1000 /tmp/test
do_check_perm "Other group"

chown 0:0 /tmp/test
chmod 664 /tmp/test
do_check_perm "Same owner, 0664 mode"

echo "--- FINAL RESULT: $COUNTER_SUCCESS/$COUNTER_ALL"
