#include "common.h"
#include <assert.h>

#define BUFLEN 40
#define NUM_BUF 3
char msg[BUFLEN] = "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX";

int main(int argc, char **argv)
{
	int fd;
	int res = 0;
	struct bpf_test test;
	if (bpf_test_load("bpf_complex.o", &test) != 0)
		return -1;

	if ((fd = open("tst", O_RDWR | O_CREAT, 0644)) < 0) {
		fprintf(stderr, "Unable to open\n");
		res = -1;
		goto cleanup;
	}

	size_t bytes_written;
	size_t bytes_after_compression;

	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);
	assert(bytes_written == 0);
	assert(bytes_after_compression == 0);

	if (write(fd, msg, BUFLEN) != BUFLEN)
		syserr("write");
	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);
	assert(bytes_written == BUFLEN);
	assert(bytes_after_compression == 28);

	char buffer[NUM_BUF][BUFLEN];
	for (int i = 0; i < NUM_BUF; i++) {
		memset(buffer[i], 'X', BUFLEN);
	}

	struct iovec iov[NUM_BUF];
	for (int i = 0; i < NUM_BUF; i++) {
		iov[i].iov_base = buffer[i];
		iov[i].iov_len = BUFLEN;
	}

	if (writev(fd, iov, NUM_BUF) != NUM_BUF * BUFLEN)
		syserr("writev");

	assert(syscall(463, fd, &bytes_written, &bytes_after_compression) == 0);
	assert(bytes_written == BUFLEN * NUM_BUF + BUFLEN);
	assert(bytes_after_compression == 28 * (NUM_BUF + 1));

	close(fd);

cleanup:
	bpf_test_cleanup(&test);
	return res;
}
